# Vector Path
# Python plug-in for GIMP 2.6/2.8
# version 1.0
# 
# This is a generator script, produces vector path based
# on series of modes / settings.
# 
#Note:
#Developed and tested with Python 2.6 only.
#
#2012-Apr
# Andrei Roslovtsev
# www.bytes-and-pixels.com
# andrei[AT]bytes-and-pixels.com

#-----------------------------------------------------------


from gimpfu import *
import sys,random as r
from math import *

ver = int(str(gimp.version[0])+str(gimp.version[1]))

def draw_path(image,drawable,path_mode,x_limit,y_limit,x_f,y_f,num_points,seed,scale,reverse):

    # Variables
    #num_points = 30
    num_coords = num_points*6  # number of values in array

    i=0   # main iterator: equals to number of items in array
    j=1   # switch to identify CAC pattern
    x=0   # x coord
    y=0   # y coord
    phi = 1.618
    phi_inv = 0.618
    pi = 3.14159265
    coords=[]   # list of coordinates
    coords_rev=[] # reverse list of coordinates
    scale = scale/100
    #path_mode=1 # 0 - random   , 1 - smooth

    x_f = x_f.replace("x","i")
    y_f = y_f.replace("y","i")
    
    r.seed(seed)
    if path_mode == 0:
        while i<num_coords:
            x=r.randint(0,x_limit)
            coords.append(x)
            y=r.randint(0,y_limit)
            coords.append(y)
            i=i+1

    if path_mode == 1:
        while i<num_coords:
            if j==1:
                x=r.randint(0,x_limit)

                coords.append(x)
                y=r.randint(0,y_limit)
                coords.append(y)
                i=i+1
                j=j+1
                continue

            if j==2:
                x=r.randint(0,x_limit)
                coords.append(x)
                y=r.randint(0,y_limit)
                coords.append(y)
                i=i+1
                j=j+1
                continue

            if j==3:
                #      anchor pos |difference between anchor & cp1 |
                x=(coords[i*2-2])+((coords[i*2-2])-(coords[i*2-4]))
                coords.append(x)
                y=(coords[i*2-1])+((coords[i*2-1])-(coords[i*2-3]))
                coords.append(y)
                i=i+1
                j=1 

    if path_mode == 3:
        x_mem = 0
        y_mem = 0
        x_prev = 0
        y_prev = 0
        axis = 'x'
        while i < num_coords/6: #get number of points
            if i==0:
                x_mem = r.randint(0,x_limit)
                y_mem = r.randint(0,y_limit)

            if i>0 and axis == 'x':
                x_mem = x_mem
                y_mem = r.randint(0,y_limit)

            if i>0 and axis == 'y':
                x_mem = r.randint(0,x_limit)
                y_mem = y_mem

            #point coords
            coords.append(x_mem)
            coords.append(y_mem)
            #tangent1 coords
            coords.append(x_mem)
            coords.append(y_mem)
            #tangent2 coords
            coords.append(x_mem)
            coords.append(y_mem)

            coords_rev.reverse()
            coords_rev.append(y_mem)
            coords_rev.append(x_mem)
            coords_rev.append(y_mem)
            coords_rev.append(x_mem)
            coords_rev.append(y_mem)
            coords_rev.append(x_mem)
            coords_rev.reverse()

            #switch axes
            if axis == 'x':
                axis = 'y'
            else:
                axis = 'x'
                
            x_prev = x_mem
            y_prev = y_mem
            
            i=i+1

    if path_mode == 4:
        x_mem = 0
        y_mem = 0
        while i < num_coords/6: #get number of points
        
            # loops vine
            #x_mem = i*4+sin(i*0.1)*100
            #y_mem = 200+sin(i*0.05)*100*cos(i*0.1)

            # loops sym
            #x_mem = i*2+(sin(i*0.05)*100)
            #y_mem = 200+sin(i*0.05)*100*cos(i*0.1)

            #loop chain border
            #x_mem = i*4+sin(i*0.1)*sin(i*0.2)*100
            #y_mem = 200+sin(i*0.1)*cos(i*0.2)*100

            #x_mem = i*6+sin(i*1.618)*sin(i*1.618)*100
            #y_mem = 200+cos(i*1.618)*sin(i*1.618)*80+sin(i*88)*200

            #sin(i)*50+sin(i*1.1)*5+i*pi+sin(i)*1.2
            #100+sin(i*1.1)*20+(sin(i)*20)

            #((i*0.8)*4)+(sin(i*0.1)*phi)+(sin(i*0.8)*10)
            #200+(sin(i*0.2)*20)*(sin(i*0.1)*phi)

            #((i*0.4)*4)+(sin(i*0.4)*phi)+(sin(i*0.6)*10)-(sin(i*0.4)*20)
            #100+(sin(i*0.2)*20)*(sin(i*0.2)*phi)

            #nice loops
            #((i*0.5)*5)+(sin(i*0.125)*100)
            #100+(sin(i*0.25)*20)+(cos(i*1)*0.25)

            x_mem = eval(x_f)
            y_mem = eval(y_f)

            #point coords
            coords.append(x_mem)
            coords.append(y_mem)
            #tangent1 coords
            coords.append(x_mem)
            coords.append(y_mem)
            #tangent2 coords
            coords.append(x_mem)
            coords.append(y_mem)

            if reverse:
                
                coords_rev.reverse()
                coords_rev.append(y_mem)
                coords_rev.append(x_mem)
                coords_rev.append(y_mem)
                coords_rev.append(x_mem)
                coords_rev.append(y_mem)
                coords_rev.append(x_mem)
                coords_rev.reverse()
                
            i=i+1
    
    vObj = pdb.gimp_vectors_new(image, 'path_')
    pdb.gimp_image_add_vectors(image, vObj, 100)
    stroke_id = pdb.gimp_vectors_stroke_new_from_points(vObj, 0,
                                                        num_coords,coords,
                                                        0)
    pdb.gimp_vectors_stroke_scale(vObj, stroke_id, scale, scale)
    
    if reverse:
        
        vObj2 = pdb.gimp_vectors_new(image, 'path_reverse_')
        pdb.gimp_image_add_vectors(image, vObj2, 100)
        stroke_id = pdb.gimp_vectors_stroke_new_from_points(vObj2, 0,
                                                            num_coords,coords_rev,
                                                            0)
    
        pdb.gimp_vectors_stroke_scale(vObj2, stroke_id, scale, scale)
    
#--------------------------------------------------------------------

def f_viewer_launch():
    #this works but plugin dialog is not showing until this window is closed:
    #import formula_viewer
    #formula_viewer.run()

    path = gimp.plug_in_directory
    
   
    # Cannot make this work:
##    import subprocess as sub
##    pdb.gimp_message('python "'+path+'\\python\\'+'formula_viewer.pyw"')
##    p = sub.call(['python '+path+'\\python\\'+'formula_viewer.pyw'])


    #this works but multiple copies a spawned when re-showing
    #the plug-in dialog (not necessarilly a bad thing):
    import os
    try:
        os.startfile(path+'\\python\\'+'formula_viewer.pyw')
    except:
        pass
    
#-----------------------------------------------------------------
register(
    "Vector_path",
    N_("Create a vector path"),
    "Create a vector path",
    "Andrei Roslovtsev",
    "www.bytes-and-pixels.com",
    "2011",
    "_Vector Path",
    "RGB*, GRAY*",
    [
        (PF_IMAGE, "image",       "Input image", None),
        (PF_DRAWABLE, "drawable", "Input drawable", None),
        (PF_OPTION, "path_mode", "Path Mode:", 4, ["Random","Random Smooth",
                                                   "Random Linear","Perpendicular","Formula"]),
        (PF_SPINNER, "x_limit", "X limit(px):", 400, (50, 2000, 10)),
        (PF_SPINNER, "y_limit", "Y limit(px):", 400, (50, 2000, 10)),
        (PF_TEXT, "x_f", "X formula:", "((i*0.5)*5)+(sin(i*0.125)*100)"),
        (PF_TEXT, "y_f", "Y formula:", "100+(sin(i*0.25)*20)+(cos(i*1)*0.25)"),
        (PF_SPINNER, "num_points", "Number of points:", 500, (2, 1000000, 1)),
        (PF_SPINNER, "seed", "Random Seed:", 1000, (1, 2000, 1)),
        (PF_SPINNER, "scale", "Scale (%):", 100, (1, 1000, 1)),
        (PF_TOGGLE, "reverse", "Reverse Path:", 1)
        ],
    [],
    draw_path,
    #menu="<Image>/File/Create/Buttons",
    menu="<Image>/Filters/Bytes-and-Pixels.com",
    domain=("gimp20-python", gimp.locale_directory),
    on_run=f_viewer_launch
    )

main()
