# Vector Path
# Vector Path Animation version
# Python plug-in for GIMP 2.6 /2.8
# version 1.0
# 
# This is a generator script, produces vector path based
# on series of modes / settings.
# Animation version generates and strokes a specified number of
# segments on separate layers, allowing for easy animation.
# 
#Note:
#
#2012-may
# Andrei Roslovtsev
# www.bytes-and-pixels.com
# andrei[AT]bytes-and-pixels.com


#-----------------------------------------------------------

from gimpfu import *
import sys,random as r
from math import *

# get Gimp version
ver = int(str(gimp.version[0])+str(gimp.version[1]))

def draw_path(image,drawable,path_mode,x_limit,y_limit,x_f,y_f,num_points,
              seed,scale,num_paths,brush=None,brush_size=None):

    # Variables
    num_coords = num_points*6  # number of values in array

    i=0   # main iterator: equals to number of items in array
    j=1   # switch to identify CAC pattern
    x=0   # x coord
    y=0   # y coord
    phi = 1.618
    phi_inv = 0.618
    pi = 3.14159265
    coords=[]   # list of coordinates
    scale = scale/100
    #path_mode=1 # 0 - random   , 1 - smooth

    x_f = x_f.replace("x","i")
    y_f = y_f.replace("y","i")
    
    r.seed(seed)
    if path_mode == 0:
        while i<num_coords:
            x=r.randint(0,x_limit)
            coords.append(x)
            y=r.randint(0,y_limit)
            coords.append(y)
            i=i+1

    if path_mode == 1:
        while i<num_coords:
            if j==1:
                x=r.randint(0,x_limit)
                coords.append(x)
                y=r.randint(0,y_limit)
                coords.append(y)
                i=i+1
                j=j+1
                continue

            if j==2:
                x=r.randint(0,x_limit)
                coords.append(x)
                y=r.randint(0,y_limit)
                coords.append(y)
                i=i+1
                j=j+1
                continue

            if j==3:
                #      anchor pos |difference between anchor & cp1 |
                x=(coords[i*2-2])+((coords[i*2-2])-(coords[i*2-4]))
                coords.append(x)
                y=(coords[i*2-1])+((coords[i*2-1])-(coords[i*2-3]))
                coords.append(y)
                i=i+1
                j=1 

    if path_mode == 3:
        x_mem = 0
        y_mem = 0
        x_prev = 0
        y_prev = 0
        axis = 'x'
        while i < num_coords/6: #get number of points
            if i==0:
                x_mem = r.randint(0,x_limit)
                y_mem = r.randint(0,y_limit)

            if i>0 and axis == 'x':
                x_mem = x_mem
                y_mem = r.randint(0,y_limit)

            if i>0 and axis == 'y':
                x_mem = r.randint(0,x_limit)
                y_mem = y_mem

            #point coords
            coords.append(x_mem)
            coords.append(y_mem)
            #tangent1 coords
            coords.append(x_mem)
            coords.append(y_mem)
            #tangent2 coords
            coords.append(x_mem)
            coords.append(y_mem)

            #switch axes
            if axis == 'x':
                axis = 'y'
            else:
                axis = 'x'
                
            x_prev = x_mem
            y_prev = y_mem
            
            i=i+1

    if path_mode == 4:
        x_mem = 0
        y_mem = 0
        while i < num_coords/6: #get number of points

            x_mem = eval(x_f)
            y_mem = eval(y_f)

            #point coords
            coords.append(x_mem)
            coords.append(y_mem)
            #tangent1 coords
            coords.append(x_mem)
            coords.append(y_mem)
            #tangent2 coords
            coords.append(x_mem)
            coords.append(y_mem)
            i=i+1
                
# Animation Version code
# Added functionality -
# generate n number of segments of the path
# stroke each segment on a new layer

    num_coords_per_path = floor((num_coords/6)/num_paths)*6
##    pdb.gimp_message('coords: '+str(num_coords))
##    pdb.gimp_message('per path: '+str(num_coords_per_path))
##    pdb.gimp_message('num paths: '+str(num_paths))
    count = 1
    start = 0
    end = 0
    
    for i in range(int(num_paths)):
       start = int((count-1)* num_coords_per_path)
       end = int(count*num_coords_per_path)

       if start == 0 and end < num_coords:
           path_coords = coords[start:end]
           count_coords = num_coords_per_path

       if start > 0 and end < num_coords:
           path_coords = coords[start-6:end]
           count_coords = num_coords_per_path+6

       if start > 0 and end == num_coords:
           path_coords = coords[start-6:end]
           count_coords = num_coords_per_path+6
       
       
       vObj = pdb.gimp_vectors_new(image, 'path_'+str(count))
       pdb.gimp_image_add_vectors(image, vObj, 100)

       stroke_id = pdb.gimp_vectors_stroke_new_from_points(vObj, 0,
                                                        count_coords,
                                                        path_coords,0)
       pdb.gimp_vectors_stroke_scale(vObj, stroke_id, scale, scale)
       count=count+1

    # get list of vectors
    num_vectors, vector_ids = pdb.gimp_image_get_vectors(image)

    width = pdb.gimp_image_width(image)
    height = pdb.gimp_image_height(image)

    if ver == 26:
        brush = pdb.gimp_context_get_brush

    if ver == 28:
        pdb.gimp_context_set_brush(brush)
        pdb.gimp_context_set_brush_size(brush_size)
    
    for i in range(int(num_vectors)):

        # no way to get'em by ID so let's get'em by Name ;)
        cur_vector = get_vectors_by_name(image,"path_"+str(i+1))
##         pdb.gimp_image_get_vectors_by_name(image, "path_"+str(i+1))
        layer = pdb.gimp_layer_new(image, width, height, 1, "layer_"+str(i+1), 100, 0)
        pdb.gimp_image_add_layer(image, layer,0)
##        pdb.gimp_image_insert_layer(image, layer, None, 0)
##        pdb.gimp_context_set_brush_size(20.0)
##        pdb.gimp_brush_set_radius(brush, 8)
        pdb.gimp_edit_stroke_vectors(layer, cur_vector)

##        pdb.gimp_context_set_brush_size(2.0)
##        pdb.gimp_brush_set_radius(brush, 3)
        pdb.gimp_edit_stroke_vectors(layer, cur_vector)
    
    #type, num_points, controlpoints, closed = pdb.gimp_vectors_stroke_get_points(vectors, stroke_id)

    
def get_vectors_by_name(image, name):
    for v in image.vectors:
        if v.name == name:
            return v
        
#--------------------------------------------------------------------

def f_viewer_launch():
    #this works but plugin dialog is not showing until this window is closed:
    #import formula_viewer
    #formula_viewer.run()

    path = gimp.plug_in_directory
    
   
    # Cannot make this work:
##    import subprocess as sub
##    pdb.gimp_message('python "'+path+'\\python\\'+'formula_viewer.pyw"')
##    p = sub.call(['python '+path+'\\python\\'+'formula_viewer.pyw'])


    #this works but multiple copies a spawned when re-showing
    #the plug-in dialog (not necessarilly a bad thing):
    import os
    try:
        os.startfile(path+'\\python\\'+'formula_viewer.pyw')
    except:
        pass

#-----------------------------------------------------------------

if ver < 28:
    params = [
        (PF_IMAGE, "image",       "Input image", None),
        (PF_DRAWABLE, "drawable", "Input drawable", None),
        (PF_OPTION, "path_mode", "Path Mode:", 4, ["Random","Random Smooth",
                                                   "Random Linear","Perpendicular","Formula"]),
        (PF_SPINNER, "x_limit", "X limit(px):", 400, (50, 2000, 10)),
        (PF_SPINNER, "y_limit", "Y limit(px):", 400, (50, 2000, 10)),
        (PF_TEXT, "x_f", "X formula:", "((i*0.5)*5)+(sin(i*0.125)*100)"),
        (PF_TEXT, "y_f", "Y formula:", "100+(sin(i*0.25)*20)+(cos(i*1)*0.25)"),
        (PF_SPINNER, "num_points", "Number of points:", 500, (2, 1000000, 1)),
        (PF_SPINNER, "seed", "Random Seed:", 1000, (1, 2000, 1)),
        (PF_SPINNER, "scale", "Scale (%):", 100, (1, 1000, 1)),
        (PF_SPINNER, "num_paths", "Segments:", 10, (1, 1000, 1)),
    ]

if ver == 28:
    params = [
        (PF_IMAGE, "image",       "Input image", None),
        (PF_DRAWABLE, "drawable", "Input drawable", None),
        (PF_OPTION, "path_mode", "Path Mode:", 4, ["Random","Random Smooth",
                                                   "Random Linear","Perpendicular","Formula"]),
        (PF_SPINNER, "x_limit", "X limit(px):", 400, (50, 2000, 10)),
        (PF_SPINNER, "y_limit", "Y limit(px):", 400, (50, 2000, 10)),
        (PF_TEXT, "x_f", "X formula:", "((i*0.5)*5)+(sin(i*0.125)*100)"),
        (PF_TEXT, "y_f", "Y formula:", "100+(sin(i*0.25)*20)+(cos(i*1)*0.25)"),
        (PF_SPINNER, "num_points", "Number of points:", 500, (2, 1000000, 1)),
        (PF_SPINNER, "seed", "Random Seed:", 1000, (1, 2000, 1)),
        (PF_SPINNER, "scale", "Scale (%):", 100, (1, 1000, 1)),
        (PF_SPINNER, "num_paths", "Segments:", 10, (1, 1000, 1)),
        (PF_BRUSH, "brush", "Brush:", 0),
        (PF_SLIDER, "brush_size", "Brush Size:", 8, (1, 100, 1))
    ]

print ver
print params
    
register(
    "Vector_path_segments",
    N_("Create vector path segments \n and stroke on separate layers\n for animation"),
    "Create vector path segments",
    "Andrei Roslovtsev",
    "www.bytes-and-pixels.com",
    "2012",
    "_Vector Path (Segments)",
    "RGB*, GRAY*",
    params,
    [],
    draw_path,
    #menu="<Image>/File/Create/Buttons",
    menu="<Image>/Filters/Bytes-and-Pixels.com",
    domain=("gimp20-python", gimp.locale_directory),
    on_run=f_viewer_launch
    )

main()
